Bug 34753 - Mono C# compiler incorrectly outputs CS0019 with reference equality to (null)
Summary: Mono C# compiler incorrectly outputs CS0019 with reference equality to (null)
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: 4.0.0
Hardware: Macintosh Mac OS
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2015-10-11 12:13 UTC by Stephen Darnell
Modified: 2015-10-12 13:00 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
Test file showing problem. (154 bytes, application/octet-stream)
2015-10-11 12:13 UTC, Stephen Darnell
Details
Attachment with text/plain mime format (154 bytes, text/plain)
2015-10-11 12:15 UTC, Stephen Darnell
Details


Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Stephen Darnell 2015-10-11 12:13:51 UTC
Created attachment 13277 [details]
Test file showing problem.

MCS incorrectly outputs CS0019 when comparing a reference against (null) in brackets.

See the attached test file with the following lines:
    Wibble w = new Wibble();
    if (w == (null)) ...

This produces:
$ mcs test.cs
test.cs(6,9): error CS0019: Operator `==' cannot be applied to operands of type `Wibble' and `null'
Compilation failed: 1 error(s), 0 warnings

Without the brackets around the null the code compiles without any error.

Obviously this test case is the smallest example I could produce and is easily modified to compile.
But the real life situation is a bit more complicated and involves generated code so it is a little tricky to 'just remove the brackets', but if this issue could be fixed, that would be great. Thanks.

OS: Mac OS-X 10.10.5
Mono: Mono JIT compiler version 4.0.4
MCS: Mono C# compiler version 4.0.4.0
Comment 1 Stephen Darnell 2015-10-11 12:15:19 UTC
Created attachment 13278 [details]
Attachment with text/plain mime format
Comment 2 Marek Safar 2015-10-12 13:00:18 UTC
Fixed in master